Index: kernel/arch/ia32xen/include/hypercall.h
===================================================================
--- kernel/arch/ia32xen/include/hypercall.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/hypercall.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -30,28 +30,39 @@
 #define KERN_ia32xen_HYPERCALL_H_
 
-#include <arch/types.h>
-#include <macros.h>
-
-typedef uint16_t domid_t;
-
-typedef struct {
-	uint8_t vector;     /**< Exception vector */
-	uint8_t flags;      /**< 0-3: privilege level; 4: clear event enable */
-	uint16_t cs;        /**< Code selector */
-	void *address;      /**< Code offset */
-} trap_info_t;
-
-
-typedef struct {
-	evtchn_t port;
-} evtchn_send_t;
-
-typedef struct {
-	uint32_t cmd;
-	union {
-		evtchn_send_t send;
-    };
-} evtchn_op_t;
-
+#ifndef __ASM__
+#	include <arch/types.h>
+#	include <macros.h>
+#endif
+
+#define GUEST_CMDLINE	1024
+#define VIRT_CPUS	32
+#define START_INFO_SIZE	1104
+
+#define BOOT_OFFSET		0x0000
+#define TEMP_STACK_SIZE 0x1000
+
+#define XEN_VIRT_START	0xFC000000
+#define XEN_CS			0xe019
+
+#define XEN_ELFNOTE_INFO			0
+#define XEN_ELFNOTE_ENTRY			1
+#define XEN_ELFNOTE_HYPERCALL_PAGE	2
+#define XEN_ELFNOTE_VIRT_BASE		3
+#define XEN_ELFNOTE_PADDR_OFFSET	4
+#define XEN_ELFNOTE_XEN_VERSION 	5
+#define XEN_ELFNOTE_GUEST_OS		6
+#define XEN_ELFNOTE_GUEST_VERSION	7
+#define XEN_ELFNOTE_LOADER			8
+#define XEN_ELFNOTE_PAE_MODE		9
+#define XEN_ELFNOTE_FEATURES		10
+#define XEN_ELFNOTE_BSD_SYMTAB		11
+
+#define mp_map ((pfn_t *) XEN_VIRT_START)
+
+#define SIF_PRIVILEGED	(1 << 0)  /**< Privileged domain */
+#define SIF_INITDOMAIN	(1 << 1)  /**< Iinitial control domain */
+
+#define XEN_CONSOLE_VGA		0x03
+#define XEN_CONSOLE_VESA	0x23
 
 #define XEN_SET_TRAP_TABLE		0
@@ -104,4 +115,136 @@
 #define DOMID_IO   (0x7FF1U)
 
+#ifndef __ASM__
+
+typedef uint16_t domid_t;
+typedef uint32_t evtchn_t;
+
+typedef struct {
+	uint32_t version;
+	uint32_t pad0;
+	uint64_t tsc_timestamp;   /**< TSC at last update of time vals */
+	uint64_t system_time;     /**< Time, in nanosecs, since boot */
+	uint32_t tsc_to_system_mul;
+	int8_t tsc_shift;
+	int8_t pad1[3];
+} vcpu_time_info_t;
+
+typedef struct {
+	uint32_t cr2;
+	uint32_t pad[5];
+} arch_vcpu_info_t;
+
+typedef struct arch_shared_info {
+	pfn_t max_pfn;                  /**< max pfn that appears in table */
+	uint32_t pfn_to_mfn_frame_list_list;
+    uint32_t nmi_reason;
+} arch_shared_info_t;
+
+typedef struct {
+	uint8_t evtchn_upcall_pending;
+	ipl_t evtchn_upcall_mask;
+	evtchn_t evtchn_pending_sel;
+	arch_vcpu_info_t arch;
+	vcpu_time_info_t time;
+} vcpu_info_t;
+
+typedef struct {
+	vcpu_info_t vcpu_info[VIRT_CPUS];
+	evtchn_t evtchn_pending[32];
+	evtchn_t evtchn_mask[32];
+	
+	uint32_t wc_version;                  /**< Version counter */
+	uint32_t wc_sec;                      /**< Secs  00:00:00 UTC, Jan 1, 1970 */
+	uint32_t wc_nsec;                     /**< Nsecs 00:00:00 UTC, Jan 1, 1970 */
+	
+	arch_shared_info_t arch;
+} shared_info_t;
+
+typedef struct {
+	int8_t magic[32];           /**< "xen-<version>-<platform>" */
+	uint32_t frames;            /**< Available frames */
+	shared_info_t *shared_info; /**< Shared info structure (machine address) */
+	uint32_t flags;             /**< SIF_xxx flags */
+	pfn_t store_mfn;            /**< Shared page (machine page) */
+	evtchn_t store_evtchn;      /**< Event channel for store communication */
+	
+	union {
+        struct {
+			pfn_t mfn;          /**< Console page (machine page) */
+			evtchn_t evtchn;    /**< Event channel for console messages */
+        } domU;
+		
+        struct {
+            uint32_t info_off;  /**< Offset of console_info struct */
+            uint32_t info_size; /**< Size of console_info struct from start */
+        } dom0;
+    } console;
+	
+	pte_t *ptl0;                /**< Boot PTL0 (kernel address) */
+	uint32_t pt_frames;         /**< Number of bootstrap page table frames */
+	pfn_t *pm_map;              /**< Physical->machine frame map (kernel address) */
+	void *mod_start;            /**< Modules start (kernel address) */
+	uint32_t mod_len;           /**< Modules size (bytes) */
+	int8_t cmd_line[GUEST_CMDLINE];
+} start_info_t;
+
+typedef struct {
+    uint8_t video_type;  
+
+    union {
+        struct {
+            uint16_t font_height;
+            uint16_t cursor_x;
+			uint16_t cursor_y;
+            uint16_t rows;
+			uint16_t columns;
+        } vga;
+
+        struct {
+            uint16_t width;
+			uint16_t height;
+            uint16_t bytes_per_line;
+            uint16_t bits_per_pixel;
+            uint32_t lfb_base;
+            uint32_t lfb_size;
+            uint8_t red_pos;
+			uint8_t red_size;
+            uint8_t green_pos;
+			uint8_t green_size;
+            uint8_t blue_pos;
+			uint8_t blue_size;
+            uint8_t rsvd_pos;
+			uint8_t rsvd_size;
+        } vesa_lfb;
+    } info;
+} console_info_t;
+
+typedef struct {
+	pfn_t start;
+	pfn_t size;
+	pfn_t reserved;
+} memzone_t;
+
+extern start_info_t start_info;
+extern shared_info_t shared_info;
+extern memzone_t meminfo;
+
+typedef struct {
+	uint8_t vector;     /**< Exception vector */
+	uint8_t flags;      /**< 0-3: privilege level; 4: clear event enable */
+	uint16_t cs;        /**< Code selector */
+	void *address;      /**< Code offset */
+} trap_info_t;
+
+typedef struct {
+	evtchn_t port;
+} evtchn_send_t;
+
+typedef struct {
+	uint32_t cmd;
+	union {
+		evtchn_send_t send;
+    };
+} evtchn_op_t;
 
 #define force_evtchn_callback() ((void) xen_version(0, 0))
@@ -235,2 +378,4 @@
 
 #endif
+
+#endif
Index: kernel/arch/ia32xen/include/mm/as.h
===================================================================
--- kernel/arch/ia32xen/include/mm/as.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/mm/as.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -48,4 +48,6 @@
 } as_arch_t;
 
+#include <genarch/mm/as_pt.h>
+
 #define as_constructor_arch(as, flags)		(as != as)
 #define as_destructor_arch(as)			(as != as)
Index: kernel/arch/ia32xen/include/mm/frame.h
===================================================================
--- kernel/arch/ia32xen/include/mm/frame.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/mm/frame.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,7 +43,4 @@
 #ifndef __ASM__
 
-#include <arch/types.h>
-#include <arch/boot/boot.h>
-
 #define PA2MA(x)	((start_info.pm_map[((uintptr_t) (x)) >> 12] << 12) + (((uintptr_t) (x)) & 0xfff))
 #define MA2PA(x)	((mp_map[((uintptr_t) (x)) >> 12] << 12) + (((uintptr_t) (x)) & 0xfff))
Index: kernel/arch/ia32xen/include/mm/memory_init.h
===================================================================
--- kernel/arch/ia32xen/include/mm/memory_init.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/mm/memory_init.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,5 @@
 #define KERN_ia32xen_MEMORY_INIT_H_
 
-#include <typedefs.h>
+#include <arch/types.h>
 
 size_t get_memory_size(void);
Index: kernel/arch/ia32xen/include/mm/page.h
===================================================================
--- kernel/arch/ia32xen/include/mm/page.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/mm/page.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -122,9 +122,7 @@
 #ifndef __ASM__
 
-#include <mm/page.h>
-#include <arch/types.h>
-#include <arch/mm/frame.h>
-#include <typedefs.h>
+#include <mm/mm.h>
 #include <arch/hypercall.h>
+#include <arch/interrupt.h>
 
 /* Page fault error codes. */
@@ -141,20 +139,4 @@
 /** When bit on this position is 1, a reserved bit was set in page directory. */ 
 #define PFERR_CODE_RSVD		(1 << 3)
-
-/** Page Table Entry. */
-struct page_specifier {
-	unsigned present : 1;
-	unsigned writeable : 1;
-	unsigned uaccessible : 1;
-	unsigned page_write_through : 1;
-	unsigned page_cache_disable : 1;
-	unsigned accessed : 1;
-	unsigned dirty : 1;
-	unsigned pat : 1;
-	unsigned global : 1;
-	unsigned soft_valid : 1;	/**< Valid content even if the present bit is not set. */
-	unsigned avl : 2;
-	unsigned frame_address : 20;
-} __attribute__ ((packed));
 
 typedef struct {
Index: kernel/arch/ia32xen/include/pm.h
===================================================================
--- kernel/arch/ia32xen/include/pm.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/pm.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -70,5 +70,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/context.h>
 
Index: kernel/arch/ia32xen/include/types.h
===================================================================
--- kernel/arch/ia32xen/include/types.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/include/types.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,4 +37,6 @@
 
 #define NULL 0
+#define false 0
+#define true 1
 
 typedef signed char int8_t;
@@ -48,4 +50,8 @@
 typedef unsigned long long uint64_t;
 
+typedef uint32_t size_t;
+typedef uint32_t count_t;
+typedef uint32_t index_t;
+
 typedef uint32_t uintptr_t;
 typedef uint32_t pfn_t;
@@ -56,5 +62,26 @@
 typedef int32_t native_t;
 
-typedef struct page_specifier pte_t;
+typedef uint8_t bool;
+typedef uint64_t task_id_t;
+typedef uint32_t context_id_t;
+
+typedef int32_t inr_t;
+typedef int32_t devno_t;
+
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;
+	unsigned writeable : 1;
+	unsigned uaccessible : 1;
+	unsigned page_write_through : 1;
+	unsigned page_cache_disable : 1;
+	unsigned accessed : 1;
+	unsigned dirty : 1;
+	unsigned pat : 1;
+	unsigned global : 1;
+	unsigned soft_valid : 1;	/**< Valid content even if the present bit is not set. */
+	unsigned avl : 2;
+	unsigned frame_address : 20;
+} __attribute__ ((packed)) pte_t;
 
 #endif
Index: kernel/arch/ia32xen/src/boot/boot.S
===================================================================
--- kernel/arch/ia32xen/src/boot/boot.S	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/boot/boot.S	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -27,7 +27,6 @@
 #
 
-#include <arch/boot/boot.h>
 #include <arch/mm/page.h>
-#include <arch/pm.h>
+#include <arch/hypercall.h>
 
 #define ELFNOTE(name, type, desctype, descval) \
Index: kernel/arch/ia32xen/src/ia32xen.c
===================================================================
--- kernel/arch/ia32xen/src/ia32xen.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/ia32xen.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <align.h>
 
@@ -55,5 +54,4 @@
 #include <arch/bios/bios.h>
 
-#include <arch/boot/boot.h>
 #include <arch/mm/memory_init.h>
 #include <interrupt.h>
Index: kernel/arch/ia32xen/src/mm/as.c
===================================================================
--- kernel/arch/ia32xen/src/mm/as.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/mm/as.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,5 @@
 
 #include <arch/mm/as.h>
-#include <genarch/mm/as_pt.h>
+#include <genarch/mm/page_pt.h>
 
 /** Architecture dependent address space init. */
Index: kernel/arch/ia32xen/src/mm/memory_init.c
===================================================================
--- kernel/arch/ia32xen/src/mm/memory_init.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/mm/memory_init.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -35,5 +35,4 @@
 #include <arch/mm/memory_init.h>
 #include <arch/mm/page.h>
-#include <arch/boot/boot.h>
 #include <print.h>
 #include <mm/frame.h>
Index: kernel/arch/ia32xen/src/pm.c
===================================================================
--- kernel/arch/ia32xen/src/pm.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/pm.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #include <config.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/interrupt.h>
 #include <arch/asm.h>
@@ -44,5 +43,4 @@
 #include <mm/slab.h>
 #include <memstr.h>
-#include <arch/boot/boot.h>
 #include <interrupt.h>
 
Index: kernel/arch/ia32xen/src/smp/apic.c
===================================================================
--- kernel/arch/ia32xen/src/smp/apic.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/smp/apic.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 #include <arch/smp/ap.h>
 #include <arch/smp/mps.h>
-#include <arch/boot/boot.h>
 #include <mm/page.h>
 #include <time/delay.h>
Index: kernel/arch/ia32xen/src/smp/mps.c
===================================================================
--- kernel/arch/ia32xen/src/smp/mps.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/smp/mps.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,5 +43,4 @@
 #include <func.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <cpu.h>
 #include <arch/asm.h>
Index: kernel/arch/ia32xen/src/smp/smp.c
===================================================================
--- kernel/arch/ia32xen/src/smp/smp.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia32xen/src/smp/smp.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 #include <arch/smp/mps.h>
 #include <arch/smp/ap.h>
-#include <arch/boot/boot.h>
 #include <genarch/acpi/acpi.h>
 #include <genarch/acpi/madt.h>
Index: kernel/arch/ia64/_link.ld.in
===================================================================
--- kernel/arch/ia64/_link.ld.in	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/_link.ld.in	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -6,6 +6,4 @@
  *
  */
-
-#define __ASM__
 
 ENTRY(kernel_image_start)
Index: kernel/arch/ia64/include/context.h
===================================================================
--- kernel/arch/ia64/include/context.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/context.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,5 +38,4 @@
 #include <arch/types.h>
 #include <arch/register.h>
-#include <typedefs.h>
 #include <align.h>
 #include <arch/stack.h>
@@ -48,5 +47,5 @@
  * One item is put onto the stack to support get_stack_base().
  */
-#define SP_DELTA	(0+ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT))
+#define SP_DELTA	(0 + ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT))
 
 #ifdef context_set
@@ -106,25 +105,25 @@
 	uint64_t pr;
 
-	__r128 f2 __attribute__ ((aligned(16)));
-	__r128 f3;
-	__r128 f4;
-	__r128 f5;
+	uint128_t f2 __attribute__ ((aligned(16)));
+	uint128_t f3;
+	uint128_t f4;
+	uint128_t f5;
 
-	__r128 f16;
-	__r128 f17;
-	__r128 f18;
-	__r128 f19;
-	__r128 f20;
-	__r128 f21;
-	__r128 f22;
-	__r128 f23;
-	__r128 f24;
-	__r128 f25;
-	__r128 f26;
-	__r128 f27;
-	__r128 f28;
-	__r128 f29;
-	__r128 f30;
-	__r128 f31;
+	uint128_t f16;
+	uint128_t f17;
+	uint128_t f18;
+	uint128_t f19;
+	uint128_t f20;
+	uint128_t f21;
+	uint128_t f22;
+	uint128_t f23;
+	uint128_t f24;
+	uint128_t f25;
+	uint128_t f26;
+	uint128_t f27;
+	uint128_t f28;
+	uint128_t f29;
+	uint128_t f30;
+	uint128_t f31;
 	
 	ipl_t ipl;
Index: kernel/arch/ia64/include/cpu.h
===================================================================
--- kernel/arch/ia64/include/cpu.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/cpu.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,6 +37,6 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/register.h>
+#include <arch/asm.h>
 
 #define FAMILY_ITANIUM	0x7
Index: kernel/arch/ia64/include/fpu_context.h
===================================================================
--- kernel/arch/ia64/include/fpu_context.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/fpu_context.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,5 +44,5 @@
 
 typedef struct {
-	__r128 fr[FRS];
+	uint128_t fr[FRS];
 } fpu_context_t;
 
Index: kernel/arch/ia64/include/interrupt.h
===================================================================
--- kernel/arch/ia64/include/interrupt.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/interrupt.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #define KERN_ia64_INTERRUPT_H_
 
-#include <typedefs.h>
 #include <arch/types.h>
 #include <arch/register.h>
@@ -65,35 +64,35 @@
 #define EOI	0		/**< The actual value doesn't matter. */
 
-struct istate {
-	__r128 f2;
-	__r128 f3;
-	__r128 f4;
-	__r128 f5;
-	__r128 f6;
-	__r128 f7;
-	__r128 f8;
-	__r128 f9;
-	__r128 f10;
-	__r128 f11;
-	__r128 f12;
-	__r128 f13;
-	__r128 f14;
-	__r128 f15;
-	__r128 f16;
-	__r128 f17;
-	__r128 f18;
-	__r128 f19;
-	__r128 f20;
-	__r128 f21;
-	__r128 f22;
-	__r128 f23;
-	__r128 f24;
-	__r128 f25;
-	__r128 f26;
-	__r128 f27;
-	__r128 f28;
-	__r128 f29;
-	__r128 f30;
-	__r128 f31;
+typedef struct {
+	uint128_t f2;
+	uint128_t f3;
+	uint128_t f4;
+	uint128_t f5;
+	uint128_t f6;
+	uint128_t f7;
+	uint128_t f8;
+	uint128_t f9;
+	uint128_t f10;
+	uint128_t f11;
+	uint128_t f12;
+	uint128_t f13;
+	uint128_t f14;
+	uint128_t f15;
+	uint128_t f16;
+	uint128_t f17;
+	uint128_t f18;
+	uint128_t f19;
+	uint128_t f20;
+	uint128_t f21;
+	uint128_t f22;
+	uint128_t f23;
+	uint128_t f24;
+	uint128_t f25;
+	uint128_t f26;
+	uint128_t f27;
+	uint128_t f28;
+	uint128_t f29;
+	uint128_t f30;
+	uint128_t f31;
 		
 	uintptr_t ar_bsp;
@@ -120,5 +119,5 @@
 	uint64_t in3;
 	uint64_t in4;
-};
+} istate_t;
 
 static inline void istate_set_retaddr(istate_t *istate, uintptr_t retaddr)
Index: kernel/arch/ia64/include/mm/as.h
===================================================================
--- kernel/arch/ia64/include/mm/as.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/mm/as.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -48,4 +48,6 @@
 } as_arch_t;
 
+#include <genarch/mm/as_ht.h>
+
 #define as_constructor_arch(as, flags)		(as != as)
 #define as_destructor_arch(as)			(as != as)
Index: kernel/arch/ia64/include/mm/page.h
===================================================================
--- kernel/arch/ia64/include/mm/page.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/mm/page.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -86,10 +86,10 @@
 #ifndef __ASM__
 
+#include <arch/mm/as.h>
 #include <arch/mm/frame.h>
+#include <arch/interrupt.h>
 #include <arch/barrier.h>
-#include <genarch/mm/page_ht.h>
 #include <arch/mm/asid.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <debug.h>
 
Index: kernel/arch/ia64/include/mm/tlb.h
===================================================================
--- kernel/arch/ia64/include/mm/tlb.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/mm/tlb.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,5 +43,4 @@
 #include <arch/interrupt.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Data and instruction Translation Register indices. */
Index: kernel/arch/ia64/include/types.h
===================================================================
--- kernel/arch/ia64/include/types.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/include/types.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,10 +36,16 @@
 #define KERN_ia64_TYPES_H_
 
-#define NULL	0
+#define NULL 0
+#define false 0
+#define true 1
 
 typedef signed char int8_t;
-typedef signed short int int16_t;
+typedef signed short int16_t;
 typedef signed int int32_t;
 typedef signed long int64_t;
+typedef struct {
+	int64_t lo;
+	int64_t hi;
+} int128_t;
 
 typedef unsigned char uint8_t;
@@ -47,13 +53,12 @@
 typedef unsigned int uint32_t;
 typedef unsigned long uint64_t;
+typedef struct {
+	uint64_t lo;
+	uint64_t hi;
+} uint128_t;
 
-typedef unsigned char __r8; 			/* Reserve byte */
-typedef unsigned short __r16;
-typedef unsigned int __r32;
-typedef unsigned long __r64;
-typedef struct __r128 {
-	__r64 lo;
-	__r64 hi;
-} __r128;
+typedef uint64_t size_t;
+typedef uint64_t count_t;
+typedef uint64_t index_t;
 
 typedef uint64_t uintptr_t;
@@ -65,5 +70,10 @@
 typedef int64_t native_t;
 
-typedef struct pte pte_t;
+typedef uint8_t bool;
+typedef uint64_t task_id_t;
+typedef uint32_t context_id_t;
+
+typedef int32_t inr_t;
+typedef int32_t devno_t;
 
 #endif
Index: kernel/arch/ia64/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia64/src/ddi/ddi.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/src/ddi/ddi.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #include <proc/task.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /** Enable I/O space range for task.
Index: kernel/arch/ia64/src/mm/page.c
===================================================================
--- kernel/arch/ia64/src/mm/page.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/src/mm/page.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -40,5 +40,4 @@
 #include <arch/mm/vhpt.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <print.h>
 #include <mm/page.h>
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -48,5 +48,4 @@
 #include <arch/pal/pal.h>
 #include <arch/asm.h>
-#include <typedefs.h>
 #include <panic.h>
 #include <print.h>
Index: kernel/arch/ia64/src/mm/vhpt.c
===================================================================
--- kernel/arch/ia64/src/mm/vhpt.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/src/mm/vhpt.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -33,4 +33,5 @@
 */
 
+#include <memstr.h>
 #include <arch/mm/vhpt.h>
 #include <mm/frame.h>
@@ -41,6 +42,6 @@
 uintptr_t vhpt_set_up(void)
 {
-	vhpt_base = frame_alloc(VHPT_WIDTH-FRAME_WIDTH,FRAME_KA | FRAME_ATOMIC);
-	if(!vhpt_base) 
+	vhpt_base = frame_alloc(VHPT_WIDTH - FRAME_WIDTH, FRAME_KA | FRAME_ATOMIC);
+	if (!vhpt_base) 
 		panic("Kernel configured with VHPT but no memory for table.");
 	vhpt_invalidate_all();
@@ -62,26 +63,24 @@
 	rid = ASID2RID(asid, vrn);
 																												
-  rr_save.word = rr_read(vrn);
-  rr.word = rr_save.word;
-  rr.map.rid = rid;
-  rr_write(vrn, rr.word);
-  srlz_i();
+	rr_save.word = rr_read(vrn);
+	rr.word = rr_save.word;
+	rr.map.rid = rid;
+	rr_write(vrn, rr.word);
+	srlz_i();
 	
 	ventry = (vhpt_entry_t *) thash(va);
-  tag = ttag(va);
-  rr_write(vrn, rr_save.word);
-  srlz_i();
-  srlz_d();
+	tag = ttag(va);
+	rr_write(vrn, rr_save.word);
+	srlz_i();
+	srlz_d();
 
-	ventry->word[0]=entry.word[0];
-	ventry->word[1]=entry.word[1];
+	ventry->word[0] = entry.word[0];
+	ventry->word[1] = entry.word[1];
 	ventry->present.tag.tag_word = tag;
-	
-
 }
 
 void vhpt_invalidate_all()
 {
-	memsetb((uintptr_t)vhpt_base,1<<VHPT_WIDTH,0);
+	memsetb((uintptr_t) vhpt_base, 1 << VHPT_WIDTH, 0);
 }
 
Index: kernel/arch/ia64/src/ski/ski.c
===================================================================
--- kernel/arch/ia64/src/ski/ski.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/ia64/src/ski/ski.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -39,5 +39,4 @@
 #include <sysinfo/sysinfo.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <ddi/device.h>
 #include <ddi/irq.h>
Index: kernel/arch/mips32/include/asm.h
===================================================================
--- kernel/arch/mips32/include/asm.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/asm.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <config.h>
 
Index: kernel/arch/mips32/include/cache.h
===================================================================
--- kernel/arch/mips32/include/cache.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/cache.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_mips32_CACHE_H_
 
-#include <typedefs.h>
+#include <arch/exception.h>
 
 extern void cache_error(istate_t *istate);
Index: kernel/arch/mips32/include/context_offset.h
===================================================================
--- kernel/arch/mips32/include/context_offset.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/context_offset.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,5 +43,5 @@
 #define OFFSET_GP      0x2c
 
-/* struct istate */
+/* istate_t */
 #define EOFFSET_AT     0x0
 #define EOFFSET_V0     0x4
Index: kernel/arch/mips32/include/cp0.h
===================================================================
--- kernel/arch/mips32/include/cp0.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/cp0.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,12 +37,11 @@
 
 #include <arch/types.h>
-#include <arch/mm/tlb.h>
 
-#define cp0_status_ie_enabled_bit	(1<<0)
-#define cp0_status_exl_exception_bit	(1<<1)
-#define cp0_status_erl_error_bit	(1<<2)
-#define cp0_status_um_bit	        (1<<4)
-#define cp0_status_bev_bootstrap_bit	(1<<22)
-#define cp0_status_fpu_bit              (1<<29)
+#define cp0_status_ie_enabled_bit	(1 << 0)
+#define cp0_status_exl_exception_bit	(1 << 1)
+#define cp0_status_erl_error_bit	(1 << 2)
+#define cp0_status_um_bit	        (1 << 4)
+#define cp0_status_bev_bootstrap_bit	(1 << 22)
+#define cp0_status_fpu_bit              (1 << 29)
 
 #define cp0_status_im_shift		8
@@ -61,6 +60,6 @@
 #define cp0_mask_all_int() cp0_status_write(cp0_status_read() & ~(cp0_status_im_mask))
 #define cp0_unmask_all_int() cp0_status_write(cp0_status_read() | cp0_status_im_mask)
-#define cp0_mask_int(it) cp0_status_write(cp0_status_read() & ~(1<<(cp0_status_im_shift+(it))))
-#define cp0_unmask_int(it) cp0_status_write(cp0_status_read() | (1<<(cp0_status_im_shift+(it))))
+#define cp0_mask_int(it) cp0_status_write(cp0_status_read() & ~(1 << (cp0_status_im_shift + (it))))
+#define cp0_unmask_int(it) cp0_status_write(cp0_status_read() | (1 << (cp0_status_im_shift + (it))))
 
 #define GEN_READ_CP0(nm,reg) static inline uint32_t cp0_ ##nm##_read(void) \
Index: kernel/arch/mips32/include/cpu.h
===================================================================
--- kernel/arch/mips32/include/cpu.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/cpu.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,4 +37,5 @@
 
 #include <arch/types.h>
+#include <arch/asm.h>
 
 typedef struct {
Index: kernel/arch/mips32/include/debugger.h
===================================================================
--- kernel/arch/mips32/include/debugger.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/debugger.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,4 @@
 #define KERN_mips32_DEBUGGER_H_
 
-#include <typedefs.h>
 #include <arch/exception.h>
 #include <arch/types.h>
Index: kernel/arch/mips32/include/exception.h
===================================================================
--- kernel/arch/mips32/include/exception.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/exception.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/cp0.h>
 
@@ -59,5 +58,5 @@
 #define EXC_VCED	31
 
-struct istate {
+typedef struct {
 	uint32_t at;
 	uint32_t v0;
@@ -96,5 +95,5 @@
 	uint32_t epc; /* cp0_epc */
 	uint32_t k1; /* We use it as thread-local pointer */
-};
+} istate_t;
 
 static inline void istate_set_retaddr(istate_t *istate, uintptr_t retaddr)
Index: kernel/arch/mips32/include/interrupt.h
===================================================================
--- kernel/arch/mips32/include/interrupt.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/interrupt.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,4 +36,5 @@
 #define KERN_mips32_INTERRUPT_H_
 
+#include <typedefs.h>
 #include <arch/exception.h>
 
Index: kernel/arch/mips32/include/mm/as.h
===================================================================
--- kernel/arch/mips32/include/mm/as.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/mm/as.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,8 +43,10 @@
 #define USER_ADDRESS_SPACE_END_ARCH		(unsigned long) 0x7fffffff
 
-#define USTACK_ADDRESS_ARCH	(0x80000000-PAGE_SIZE)
+#define USTACK_ADDRESS_ARCH	(0x80000000 - PAGE_SIZE)
 
 typedef struct {
 } as_arch_t;
+
+#include <genarch/mm/as_pt.h>
 
 #define as_constructor_arch(as, flags)		(as != as)
Index: kernel/arch/mips32/include/mm/page.h
===================================================================
--- kernel/arch/mips32/include/mm/page.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/mm/page.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,9 +44,9 @@
 
 #ifndef __ASM__
-#  define KA2PA(x)	(((uintptr_t) (x)) - 0x80000000)
-#  define PA2KA(x)	(((uintptr_t) (x)) + 0x80000000)
+#	define KA2PA(x)	(((uintptr_t) (x)) - 0x80000000)
+#	define PA2KA(x)	(((uintptr_t) (x)) + 0x80000000)
 #else
-#  define KA2PA(x)	((x) - 0x80000000)
-#  define PA2KA(x)	((x) + 0x80000000)
+#	define KA2PA(x)	((x) - 0x80000000)
+#	define PA2KA(x)	((x) + 0x80000000)
 #endif
 
@@ -110,8 +110,6 @@
 #ifndef __ASM__
 
-#include <arch/mm/tlb.h>
-#include <mm/page.h>
-#include <arch/mm/frame.h>
-#include <arch/types.h>
+#include <mm/mm.h>
+#include <arch/exception.h>
 
 static inline int get_pt_flags(pte_t *pt, index_t i)
Index: kernel/arch/mips32/include/mm/tlb.h
===================================================================
--- kernel/arch/mips32/include/mm/tlb.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/arch/mips32/include/mm/tlb.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/exception.h>
-#include <typedefs.h>
 
 #ifdef TLBCNT
@@ -53,10 +52,5 @@
 #define PAGE_CACHEABLE_EXC_WRITE	5
 
-typedef union entry_lo entry_lo_t;
-typedef union entry_hi entry_hi_t;
-typedef union page_mask page_mask_t;
-typedef union index tlb_index_t;
-
-union entry_lo {
+typedef union {
 	struct {
 #ifdef BIG_ENDIAN
@@ -77,20 +71,7 @@
 	} __attribute__ ((packed));
 	uint32_t value;
-};
+} entry_lo_t;
 
-/** Page Table Entry. */
-struct pte {
-	unsigned g : 1;			/**< Global bit. */
-	unsigned p : 1;			/**< Present bit. */
-	unsigned d : 1;			/**< Dirty bit. */
-	unsigned cacheable : 1;		/**< Cacheable bit. */
-	unsigned : 1;			/**< Unused. */
-	unsigned soft_valid : 1;	/**< Valid content even if not present. */
-	unsigned pfn : 24;		/**< Physical frame number. */
-	unsigned w : 1;			/**< Page writable bit. */
-	unsigned a : 1;			/**< Accessed bit. */
-};
-
-union entry_hi {
+typedef union {
 	struct {
 #ifdef BIG_ENDIAN
@@ -105,7 +86,7 @@
 	} __attribute__ ((packed));
 	uint32_t value;
-};
+} entry_hi_t;
 
-union page_mask {
+typedef union {
 	struct {
 #ifdef BIG_ENDIAN
@@ -120,7 +101,7 @@
 	} __attribute__ ((packed));
 	uint32_t value;
-};
+} page_mask_t;
 
-union index {
+typedef union {
 	struct {
 #ifdef BIG_ENDIAN
@@ -135,5 +116,5 @@
 	} __attribute__ ((packed));
 	uint32_t value;
-};
+} tlb_index_t;
 
 /** Probe TLB for Matching Entry
